# Generated from primitive_wrapper-2.3.0.gem by gem2rpm -*- rpm-spec -*-
%global gem_name primitive_wrapper

Name: rubygem-%{gem_name}
Version: 2.3.0
Release: 1%{?dist}
Summary: Thin wrapper for primitive literals
License: MIT
Source0: https://rubygems.org/gems/%{gem_name}-%{version}.gem
BuildRequires: ruby(release)
BuildRequires: rubygems-devel
BuildRequires: ruby >= 2.2.0
# BuildRequires: rubygem(rspec) >= 3.0
# BuildRequires: rubygem(rspec) < 4
# BuildRequires: rubygem(byebug) >= 5.0
# BuildRequires: rubygem(byebug) < 6
# BuildRequires: rubygem(byebug) >= 5.0.0
BuildArch: noarch

%description
This gem creates a thin shell to encapsulate primitive literal types such as
integers, floats and symbols.
There are a family of wrappers which mimic the behavior of what they contain.
Primitive types have several drawbacks: no constructor to call, can't create
instance variables, and can't create singleton methods.
There is some utility in wrapping a primitive type. You can simulate a call by
reference for example.
You can also simulate mutability, and pointers.
Some wrappers are dedicated to holding a single type while others may hold a
family of types such as the `Number` wrapper.
What is interesting to note is Number objects do not derive from `Numeric`,
but instead derive from `Value` (the wrapper base class);
but at the same time, `Number` objects mimic the methods of `Fixnum`,
`Complex`, `Float`, etc.
Many of the wrappers can be used in an expression without having to call an
access method.
There are also new types: `Bool` which wraps `true,false` and `Property` which
wraps `Hash` types.
The `Property` object auto-methodizes the key names of the Hash.
Also `Fraction` supports mixed fractions.


%package doc
Summary: Documentation for %{name}
Requires: %{name} = %{version}-%{release}
BuildArch: noarch

%description doc
Documentation for %{name}.

%prep
%setup -q -n %{gem_name}-%{version}

%build
# Create the gem as gem install only works on a gem file
gem build ../%{gem_name}-%{version}.gemspec

# %%gem_install compiles any C extensions and installs the gem into ./%%gem_dir
# by default, so that we can move it into the buildroot in %%install
%gem_install

%install
mkdir -p %{buildroot}%{gem_dir}
cp -a .%{gem_dir}/* \
        %{buildroot}%{gem_dir}/



%check
pushd .%{gem_instdir}
# rspec spec
popd

%files
%dir %{gem_instdir}
%exclude %{gem_instdir}/.gitignore
%exclude %{gem_instdir}/.travis.yml
%{gem_instdir}/CODE_OF_CONDUCT.md
%license %{gem_instdir}/LICENSE.txt
%{gem_instdir}/bin
%{gem_libdir}
%exclude %{gem_cache}
%{gem_spec}

%files doc
%doc %{gem_docdir}
%exclude %{gem_instdir}/.rspec
%{gem_instdir}/Gemfile
%doc %{gem_instdir}/README.md
%{gem_instdir}/Rakefile
%{gem_instdir}/primitive_wrapper.gemspec

%changelog
* Tue Aug 24 2021 mockbuilder - 2.3.0-1
- Initial package
